local version = "1.9.1"

--------------------------------------------------------------
--GUI functions for drawing frames
--------------------------------------------------------------
local function DrawGroup1a(container) --Ground Mounts, Tab1
  container:SetLayout("Flow")
    
  local selectallbutton = AceGUI:Create("Button")
  selectallbutton:SetText("Select All")
  selectallbutton:SetCallback("OnClick", function() YayMounts:SelectAllMounts("ground") end)
  container:AddChild(selectallbutton)
    
  local clearallbutton = AceGUI:Create("Button")
  clearallbutton:SetText("Clear All")
  clearallbutton:SetCallback("OnClick", function() YayMounts:ClearMounts("ground") end)
  container:AddChild(clearallbutton)
  
  local scrollcontainerframe = AceGUI:Create("SimpleGroup")
  scrollcontainerframe:SetLayout("Fill")
  scrollcontainerframe:SetFullWidth(true)
  scrollcontainerframe:SetFullHeight(true)
  container:AddChild(scrollcontainerframe)

  local scrollframe = AceGUI:Create("ScrollFrame")
  scrollcontainerframe:AddChild(scrollframe)
  
  
  YayMountsContent = AceGUI:Create("InlineGroup")
  YayMountsContent:SetFullWidth(true)
  YayMountsContent:SetLayout("Flow")
  
  YayMounts:BuildList("ground")
  scrollframe:AddChild(YayMountsContent)
end

local function DrawGroup2a(container) --Flying Mounts, Tab2
  container:SetLayout("Flow")
  
  local selectallbutton = AceGUI:Create("Button")
  selectallbutton:SetText("Select All")
  selectallbutton:SetCallback("OnClick", function() YayMounts:SelectAllMounts("fly") end)
  container:AddChild(selectallbutton)
    
  local clearallbutton = AceGUI:Create("Button")
  clearallbutton:SetText("Clear All")
  clearallbutton:SetCallback("OnClick", function() YayMounts:ClearMounts("fly") end)
  container:AddChild(clearallbutton)
  
  local scrollcontainerframe = AceGUI:Create("SimpleGroup")
  scrollcontainerframe:SetLayout("Fill")
  scrollcontainerframe:SetFullWidth(true)
  scrollcontainerframe:SetFullHeight(true)
  container:AddChild(scrollcontainerframe)

  local scrollframe = AceGUI:Create("ScrollFrame")
  scrollcontainerframe:AddChild(scrollframe)
  
  YayMountsContent = AceGUI:Create("InlineGroup")
  YayMountsContent:SetFullWidth(true)
  YayMountsContent:SetLayout("Flow")
  
  YayMounts:BuildList("fly")
  scrollframe:AddChild(YayMountsContent)
end

local function DrawGroup3a(container) --Profession Mounts, Tab3
	container:SetLayout("Flow")
	
	local selectallbutton = AceGUI:Create("Button")
	selectallbutton:SetText("Select All")
	selectallbutton:SetCallback("OnClick", 
		function() 
			for spellID,v in pairs(YayMounts.db.profile.mounts) do
				if t[spellID] ~= nil and YayMountsType["Professions"][spellID] ~= nil then
					YayMounts.db.profile.mounts[spellID][1] = true
					t[spellID]:SetValue(true)
				end
			end
		end)
	container:AddChild(selectallbutton)

	local clearallbutton = AceGUI:Create("Button")
	clearallbutton:SetText("Clear All")
	clearallbutton:SetCallback("OnClick", 
		function() 
			for spellID,v in pairs(YayMounts.db.profile.mounts) do
				if t[spellID] ~= nil and YayMountsType["Professions"][spellID] ~= nil then
					YayMounts.db.profile.mounts[spellID][1] = false
					t[spellID]:SetValue(false)
				end
			end
		end)
	container:AddChild(clearallbutton)

	local scrollcontainerframe = AceGUI:Create("SimpleGroup")
	scrollcontainerframe:SetLayout("Fill")
	scrollcontainerframe:SetFullWidth(true)
	scrollcontainerframe:SetFullHeight(true)
	container:AddChild(scrollcontainerframe)

	local scrollframe = AceGUI:Create("ScrollFrame")
	scrollcontainerframe:AddChild(scrollframe)

	YayMountsContent = AceGUI:Create("InlineGroup")
	YayMountsContent:SetFullWidth(true)
	YayMountsContent:SetLayout("Flow")


	YayMounts:BuildList("profession")
	scrollframe:AddChild(YayMountsContent)
end

local function DrawGroup4a(container) --Special Mounts, Tab4
  container:SetLayout("Flow")
  
  local selectallbutton = AceGUI:Create("Button")
  selectallbutton:SetText("Select All")
  selectallbutton:SetCallback("OnClick", function() YayMounts:SelectAllMounts("special") end)
  container:AddChild(selectallbutton)
    
  local clearallbutton = AceGUI:Create("Button")
  clearallbutton:SetText("Clear All")
  clearallbutton:SetCallback("OnClick", function() YayMounts:ClearMounts("special") end)
  container:AddChild(clearallbutton)
    
  local scrollcontainerframe = AceGUI:Create("SimpleGroup")
  scrollcontainerframe:SetLayout("Fill")
  scrollcontainerframe:SetFullWidth(true)
  scrollcontainerframe:SetFullHeight(true)
  container:AddChild(scrollcontainerframe)
    
  local scrollframe = AceGUI:Create("ScrollFrame")
  scrollcontainerframe:AddChild(scrollframe)
    
  YayMountsContent = AceGUI:Create("InlineGroup")
  YayMountsContent:SetFullWidth(true)
  YayMountsContent:SetLayout("Flow")
    
  
  YayMounts:BuildList("special")
  scrollframe:AddChild(YayMountsContent)
end

local function SelectGroupMounts(container, event, group)
	container:ReleaseChildren()
	if group == "tab1" then
		DrawGroup1a(container)
	elseif group == "tab2" then
		DrawGroup2a(container)
	elseif group == "tab3" then
		DrawGroup3a(container)
	elseif group == "tab4" then
		DrawGroup4a(container)
	end
	currentSubTab = group
end

local function DrawGroup1(container)--MOUNTS
  container:SetLayout("Fill")

  local tab  = AceGUI:Create("TabGroup")
  tab:SetLayout("Flow")
  tab:SetTabs({{text="Ground ("..YayMounts.db.profile.misc.NumMounts["Ground"]..")", value="tab1"}, {text="Flying ("..YayMounts.db.profile.misc.NumMounts["Flying"]..")", value="tab2"}, {text="Profession ("..YayMounts.db.profile.misc.NumMounts["Profession"]..")", value="tab3"}, {text="Special ("..YayMounts.db.profile.misc.NumMounts["Special"]..")", value="tab4"}})
  tab:SetCallback("OnGroupSelected", SelectGroupMounts)
  
  if currentSubTab ~= nil then
    tab:SelectTab(currentSubTab)
  else
    tab:SelectTab("tab1")
  end
  container:AddChild(tab)
end

local function DrawGroup2(container)--MOUNT OPTIONS
	container:SetLayout("Flow")
  
	local yayMountsBindingButton = AceGUI:Create("Keybinding")
	local yayMountsBindingButton2 = AceGUI:Create("Keybinding")
	local yayMountsBindingButton3 = AceGUI:Create("Keybinding")
	local yayMountsBindingButton4 = AceGUI:Create("Keybinding")
	
	yayMountsBindingButton:SetLabel(BINDING_NAME_YAYMOUNTBINDING)
	yayMountsBindingButton:SetKey(GetBindingKey("YAYMOUNTBINDING"))
	yayMountsBindingButton:SetCallback("OnKeyChanged", 
		function() 
			YayMounts:Keybinding(yayMountsBindingButton:GetKey(), 1) 
			YayMounts:UpdateBindingButtons(yayMountsBindingButton, yayMountsBindingButton2, yayMountsBindingButton3, yayMountsBindingButton4)
		end)
	container:AddChild(yayMountsBindingButton)

	
	yayMountsBindingButton2:SetLabel(BINDING_NAME_YAYMOUNTBINDING2)
	yayMountsBindingButton2:SetKey(GetBindingKey("YAYMOUNTBINDING2"))
	yayMountsBindingButton2:SetCallback("OnKeyChanged", 
		function() 
			YayMounts:Keybinding(yayMountsBindingButton2:GetKey(), 2); 
			YayMounts:UpdateBindingButtons(yayMountsBindingButton, yayMountsBindingButton2, yayMountsBindingButton3, yayMountsBindingButton4)
		end)
	container:AddChild(yayMountsBindingButton2)
  
	
	yayMountsBindingButton3:SetLabel(BINDING_NAME_YAYMOUNTBINDING3)
	yayMountsBindingButton3:SetKey(GetBindingKey("YAYMOUNTBINDING3"))
	yayMountsBindingButton3:SetCallback("OnKeyChanged", 
		function() 
			YayMounts:Keybinding(yayMountsBindingButton3:GetKey(), 3); 
			YayMounts:UpdateBindingButtons(yayMountsBindingButton, yayMountsBindingButton2, yayMountsBindingButton3, yayMountsBindingButton4)
		end)
	container:AddChild(yayMountsBindingButton3)
	
	
	yayMountsBindingButton4:SetLabel(BINDING_NAME_YAYMOUNTBINDING4)
	yayMountsBindingButton4:SetKey(GetBindingKey("YAYMOUNTBINDING4"))
	yayMountsBindingButton4:SetCallback("OnKeyChanged", 
		function() 
			YayMounts:Keybinding(yayMountsBindingButton4:GetKey(), 4); 
			YayMounts:UpdateBindingButtons(yayMountsBindingButton, yayMountsBindingButton2, yayMountsBindingButton3, yayMountsBindingButton4)
		end)
	container:AddChild(yayMountsBindingButton4)

	-- No dismount while flying
	local nDWF = AceGUI:Create("CheckBox")
	nDWF:SetLabel(YayMountsLocale.String.NDWF)
	nDWF:SetValue(YayMounts:GetDbValue("settings", "NDWF"))
	nDWF:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "NDWF", nDWF:GetValue()) end)
	nDWF:SetFullWidth(true)
	container:AddChild(nDWF)
	
	-- Use Telaari Talbuk (or horde version) in Nagrand
	local telaari = AceGUI:Create("CheckBox")
	telaari:SetLabel(YayMountsLocale.String.TELAARI)
	telaari:SetValue(YayMounts:GetDbValue("settings", "TELAARI"))
	telaari:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "TELAARI", telaari:GetValue()) end)
	telaari:SetFullWidth(true)
	container:AddChild(telaari)

	-- Emergency random mount if no mounts useable from selected mounts
	local emptyRandom = AceGUI:Create("CheckBox")
	emptyRandom:SetLabel(YayMountsLocale.String.ER)
	emptyRandom:SetValue(YayMounts:GetDbValue("settings", "ER"))
	emptyRandom:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "ER", emptyRandom:GetValue()) end)
	emptyRandom:SetFullWidth(true)
	container:AddChild(emptyRandom)

	local forceFlyingMount = AceGUI:Create("CheckBox")
	forceFlyingMount:SetLabel(YayMountsLocale.String.FFM)
	forceFlyingMount:SetValue(YayMounts:GetDbValue("settings", "FFM"))
	forceFlyingMount:SetCallback("OnValueChanged", function() YayMounts:SetDbValue("settings", "FFM", forceFlyingMount:GetValue()) end)
	forceFlyingMount:SetFullWidth(true)
	container:AddChild(forceFlyingMount)

	local sliderRepairMount = AceGUI:Create("Slider") --repair mount slider in decimal %
	sliderRepairMount:SetLabel("Low Durability %")
	sliderRepairMount:SetValue(YayMounts:GetDbValue("misc", "MinDurability")*100)
	sliderRepairMount:SetCallback("OnMouseUp", function() YayMounts:SetDbValue("misc", "MinDurability", (sliderRepairMount:GetValue()/100)) end)
	sliderRepairMount:SetSliderValues(0, 100, 5)
	sliderRepairMount:SetDisabled( not YayMounts:GetDbValue("settings", "URM"))

	local repairMount = AceGUI:Create("CheckBox")
	repairMount:SetLabel(YayMountsLocale.String.URM)
	repairMount:SetValue(YayMounts:GetDbValue("settings", "URM"))
	repairMount:SetCallback("OnValueChanged", function() YayMounts:SetDbValue("settings", "URM", repairMount:GetValue()) sliderRepairMount:SetDisabled(not repairMount:GetValue()) end)
	repairMount:SetFullWidth(true)
  
	container:AddChild(repairMount)
	container:AddChild(sliderRepairMount)
  
	if GetItemCount(37011, false) > 0 then
		local flyingBroomPriority = AceGUI:Create("CheckBox")
		flyingBroomPriority:SetLabel(YayMountsLocale.String.FBP)
		flyingBroomPriority:SetValue(YayMounts:GetDbValue("settings", "FBP"))
		flyingBroomPriority:SetCallback("OnValueChanged", function() YayMounts:SetDbValue("settings", "FBP", flyingBroomPriority:GetValue()) end)
		flyingBroomPriority:SetFullWidth(true)
		container:AddChild(flyingBroomPriority)
	end
end

local function DrawGroup3(container) --CLASS OPTIONS
  container:SetLayout("Flow")
  
  if YayMountsState.class == "MONK" then
    local monkRoll = AceGUI:Create("CheckBox")
    monkRoll:SetLabel(YayMountsLocale.String.MR)
    monkRoll:SetValue(YayMounts:GetDbValue("settings", "MR"))
    monkRoll:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "MR", monkRoll:GetValue()) end)
    monkRoll:SetFullWidth(true)
    container:AddChild(monkRoll)
  end
  
  if YayMountsState.class == "ROGUE" then
    local rogueSprint = AceGUI:Create("CheckBox")
    rogueSprint:SetLabel(YayMountsLocale.String.RS)
    rogueSprint:SetValue(YayMounts:GetDbValue("settings", "RS"))
    rogueSprint:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "RS", rogueSprint:GetValue()) end)
    rogueSprint:SetFullWidth(true)
    container:AddChild(rogueSprint)
  end
  
  if YayMountsState.class == "DRUID" then
    local flightFormPriority = AceGUI:Create("CheckBox")
    flightFormPriority:SetLabel(YayMountsLocale.String.FFP)
    flightFormPriority:SetValue(YayMounts:GetDbValue("settings", "FFP"))
    flightFormPriority:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "FFP", flightFormPriority:GetValue()) end)
    flightFormPriority:SetFullWidth(true)
    container:AddChild(flightFormPriority)
    
    local travelToTravel = AceGUI:Create("CheckBox")
    travelToTravel:SetLabel(YayMountsLocale.String.TTT)
    travelToTravel:SetValue(YayMounts:GetDbValue("settings", "TTT"))
    travelToTravel:SetCallback("OnValueChanged", function() YayMounts:SetDbValue("settings", "TTT", travelToTravel:GetValue()) end)
    travelToTravel:SetFullWidth(true)
    container:AddChild(travelToTravel)
    
    local mountToFlightForm = AceGUI:Create("CheckBox")
    mountToFlightForm:SetLabel(YayMountsLocale.String.MTFF)
    mountToFlightForm:SetValue(YayMounts:GetDbValue("settings", "MTFF"))
    mountToFlightForm:SetCallback("OnValueChanged", function() YayMounts:SetDbValue("settings", "MTFF", mountToFlightForm:GetValue()) end)
    mountToFlightForm:SetFullWidth(true)
    container:AddChild(mountToFlightForm)
  end
  
  if YayMountsState.class == "MAGE" then
    local pMLS = AceGUI:Create("CheckBox")
    pMLS:SetLabel(YayMountsLocale.String.MS)
    pMLS:SetValue(YayMounts:GetDbValue("settings", "PMLS"))
    pMLS:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "PMLS", pMLS:GetValue()) end)
    pMLS:SetFullWidth(true)
    container:AddChild(pMLS)
  end
  
  if YayMountsState.class == "PRIEST" then
    local pMLS = AceGUI:Create("CheckBox")
    pMLS:SetLabel(YayMountsLocale.String.PL)
    pMLS:SetValue(YayMounts:GetDbValue("settings", "PMLS"))
    pMLS:SetCallback("OnValueChanged",  function() YayMounts:SetDbValue("settings", "PMLS", pMLS:GetValue()) end)
    pMLS:SetFullWidth(true)
    container:AddChild(pMLS)
  end
end

local function DrawGroup4(container) --PROFILE OPTIONS
  container:SetLayout("List")
  local cPV, tempStr = 1, YayMounts.db:GetCurrentProfile()
  
  for k,v in pairs(YayMountsDB.tProfiles) do
    if v == tempStr then
      cPV = k
    end
  end
  
  local createProfile = AceGUI:Create("EditBox")
  createProfile:SetLabel("Create new Profile")
  createProfile:SetMaxLetters(15) 
  
  local currentProfile = AceGUI:Create("Dropdown")
  currentProfile:SetList(YayMountsDB.tProfiles)
  currentProfile:SetLabel("Current Profile:")
  currentProfile:SetValue(cPV)
  
  local copyFrom = AceGUI:Create("Dropdown")
  copyFrom:SetList(YayMountsDB.tProfiles)
  copyFrom:SetItemDisabled(cPV, true)
  copyFrom:SetLabel("Copy settings from:")

  
  local copyButton = AceGUI:Create("Button")
  copyButton:SetWidth(75)
  copyButton:SetText("Copy")
  copyButton:SetDisabled(true)
  
  local deleteSelect = AceGUI:Create("Dropdown")
  deleteSelect:SetList(YayMountsDB.tProfiles)
  deleteSelect:SetItemDisabled(cPV, true)
  deleteSelect:SetLabel("Delete profile:")
  
  local deleteButton = AceGUI:Create("Button")
  deleteButton:SetWidth(100)
  deleteButton:SetText("Delete")
  deleteButton:SetDisabled(true)
  
  --Callbacks
  createProfile:SetCallback("OnEnterPressed", 
	function()
		local newProfileName = createProfile:GetText()
	
		--Check if there already is a profile with this name
		for k,v in pairs(YayMountsDB.tProfiles) do
			if(newProfileName == v) then
				return
			end
		end
	
		local tempKey = cPV
		if newProfileName ~= "" then
			YayMounts.db:SetProfile(newProfileName) 

			-- Update the dropdown lists
			YayMounts:AlphaSortProfileDB()
			currentProfile:SetList(YayMountsDB.tProfiles)
			copyFrom:SetList(YayMountsDB.tProfiles)
			deleteSelect:SetList(YayMountsDB.tProfiles)
	  
			-- Select the new profile
			if currentProfile:GetValue() ~= newProfileName then
				for k,v in pairs(YayMountsDB.tProfiles) do
				  if v == newProfileName then
					tempKey = k
				  end
				end
				currentProfile:SetValue(tempKey)
				copyFrom:SetItemDisabled(tempKey, true)
				copyFrom:SetItemDisabled(cPV, false)
				deleteSelect:SetItemDisabled(tempKey, true)
				deleteSelect:SetItemDisabled(cPV, false)
				cPV = currentProfile:GetValue()
				createProfile:SetText("")
				YayMounts:ReSort()
			end
		end
	end)
  
	currentProfile:SetCallback("OnValueChanged", 
		function() 
			if currentProfile:GetValue() ~= cPV then 
				YayMounts.db:SetProfile(YayMountsDB.tProfiles[currentProfile:GetValue()])
				copyFrom:SetItemDisabled(currentProfile:GetValue(), true)
				copyFrom:SetItemDisabled(cPV, false)
				deleteSelect:SetItemDisabled(currentProfile:GetValue(), true)
				deleteSelect:SetItemDisabled(cPV, false)
				deleteSelect:SetValue(nil)
				cPV = currentProfile:GetValue() 
			end 
		end)
  
	copyFrom:SetCallback("OnValueChanged", 
		function() 
			copyButton:SetDisabled(false) 
		end)
  
	copyButton:SetCallback("OnClick", 
		function() 
			YayMounts.db:CopyProfile(YayMountsDB.tProfiles[copyFrom:GetValue()], true) 
			copyFrom:SetValue(nil) 
			copyButton:SetDisabled(true)
			YayMounts:ReSort()
		end)
  
  deleteSelect:SetCallback("OnValueChanged", 
	function()
		if deleteSelect:GetValue() ~= nil then
		  deleteButton:SetDisabled(false) 
		else
		  deleteButton:SetDisabled(true)
		end
	end)
  
  deleteButton:SetCallback("OnClick", 
	function()
		if(copyFrom:GetValue() == deleteSelect:GetValue()) then
			copyFrom:SetValue(nil)
		end
		
		YayMounts.db:DeleteProfile(YayMountsDB.tProfiles[deleteSelect:GetValue()], true)
		deleteSelect:SetValue(nil) 
		deleteButton:SetDisabled(true)
		YayMounts:AlphaSortProfileDB()
		currentProfile:SetList(YayMountsDB.tProfiles)
		copyFrom:SetList(YayMountsDB.tProfiles)
		deleteSelect:SetList(YayMountsDB.tProfiles)
		deleteSelect:SetItemDisabled(1, true)
		deleteSelect:SetItemDisabled(cPV, true)
	end)
  
  container:AddChild(createProfile)
  container:AddChild(currentProfile)
  container:AddChild(copyFrom)
  container:AddChild(copyButton)
  container:AddChild(deleteSelect)
  container:AddChild(deleteButton)
end

local function SelectGroup(container, event, group)-- Callback function for OnGroupSelected
  container:ReleaseChildren()
  if group == "tab1" then
    DrawGroup1(container)
  elseif group == "tab2" then
    DrawGroup2(container)
  elseif group == "tab3" then
    DrawGroup3(container)
  elseif group == "tab4" then
    DrawGroup4(container)
  end
  currentTab = group
end

function YayMounts:Frames(selectedTab)-- Basic frame
  if not yayFrame then 
    yayFrame = AceGUI:Create("Frame")
    yayFrame:SetCallback("OnClose", function(widget) AceGUI:Release(widget); yayFrame = nil end)
    yayFrame:SetTitle("Yay Mounts")
    yayFrame:SetStatusText("Version "..version..", by Cyrae - Windrunner US & Anzu - Kirin Tor US")
    yayFrame:SetLayout("Fill")
    yayFrame:SetWidth(720)
    yayFrame:SetHeight(490)
    
    local tTabs = {
      {text="Mounts ("..self.db.profile.misc.NumMounts["Total"]..")", value="tab1"}, 
      {text="Mount Options", value="tab2"}, 
      {text="Profile Options", value="tab4"},
    }
  
    if YayMountsState.class == "MAGE" or YayMountsState.class == "PRIEST" or YayMountsState.class == "DRUID" or YayMountsState.class == "MONK" or YayMountsState.class == "ROGUE" then
      tinsert(tTabs, 3, {text=""..YayMountsState.localClass.." Options", value = "tab3"})
    end
  
    local tab = AceGUI:Create("TabGroup")
    tab:SetLayout("Flow")
    tab:SetTabs(tTabs)
    tab:SetCallback("OnGroupSelected", SelectGroup)
    tab:SelectTab(selectedTab)
    yayFrame:AddChild(tab)
    
  else
    AceGUI:Release(yayFrame)
    yayFrame, currentTab, currentSubTab = nil
  end
end
